//+------------------------------------------------------------------+
//|                                                     5matf.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011"
#property link      ""

#import "5MATL.ex4"
   int TREND_alexcud(int argTimeFrame1, int argTimeFrame2, int argTimeFrame3,
                     int argTrendPeriod1, int argTrendPeriod2, int argTrendPeriod3, int argTrendPeriod4, int argTrendPeriod5);

string ExpertName ="5MATL EA v2";

extern bool    ECNBroker      = true; 
extern int     StopLoss       = 5;
extern int     TakeProfit     = 10;
extern int     TrailingStop   = 0;
extern double  Lots           = 0.1;
extern int     Slippage       = 3;
extern int     MagicNumber    = 58132134;
extern int     OpenLevel      = 0;
extern int     CloseLevel     = 1;
extern int     TimeFrame1     = 15;
extern int     TimeFrame2     = 60;
extern int     TimeFrame3     = 240;
extern int     TrendPeriod1   = 5;
extern int     TrendPeriod2   = 8;
extern int     TrendPeriod3   = 13;
extern int     TrendPeriod4   = 21;
extern int     TrendPeriod5   = 34;
 
int Signal;
double SL,TP,trailingstop,point = 0;

int init()
{
Comment(ExpertName);
double pipMultiplier = 1;
   if (Digits==3 || Digits==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;
                  
   point = Point*pipMultiplier;
   trailingstop=point*TrailingStop;        
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{         
Signal=TREND_alexcud(TimeFrame1,TimeFrame2,TimeFrame3,TrendPeriod1,TrendPeriod2,TrendPeriod3,TrendPeriod4,TrendPeriod5);

int Total=0;
for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
   OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber )
      {
      Total++;
            if(OrderType()==OP_BUY)
         {
         if(Signal<-CloseLevel)
            {
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage);
            return(0);
            }
         if(TrailingStop>0
         && Bid-OrderOpenPrice()>trailingstop
         && OrderStopLoss()<Bid-trailingstop)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),Bid-trailingstop,OrderTakeProfit(),0);
            return(0);
            }
         }
      if(OrderType()==OP_SELL)
         {
         if(Signal>CloseLevel)
            {
            OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*point);
            return(0);
            }
         if(TrailingStop>0
         && OrderOpenPrice()-Ask>trailingstop
         && (OrderStopLoss()>Ask+trailingstop || OrderStopLoss()==0))
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),Ask+trailingstop,OrderTakeProfit(),0);
            return(0);
            }
         }
      }
   }
if(Total==0)
   {
   if(Signal>OpenLevel)
      {
      
      SL=0;TP=0;
      if(StopLoss>0)   SL=Ask-point*StopLoss;
      if(TakeProfit>0) TP=Ask+point*TakeProfit;
      
      Place_Order(OP_BUY,Lots,Ask,Slippage,SL,TP,ExpertName,Green);
      return(0);
      }
      
   if(Signal<OpenLevel)
      {
      
      SL=0;TP=0;
      if(StopLoss>0)   SL=Bid+point*StopLoss;
      if(TakeProfit>0) TP=Bid-point*TakeProfit;
      
      Place_Order(OP_SELL,Lots,Bid,Slippage,SL,TP,ExpertName,Green);   
      return(0);
      }
   }
  return(0);
}

int Place_Order(int argOrderType, int argLots, double argPrice, double argSlippage,double argSL, double argTP, string argComment, color argColor )
{
   int Ticket;
   if (!ECNBroker)
   		       Ticket=OrderSend(Symbol(),argOrderType,argLots,argSlippage*point,argSL,argTP,argComment,MagicNumber,0,argColor);		    
          else 
             {
                Ticket=OrderSend(Symbol(),argOrderType,argLots,argSlippage*point,0,0,argComment,MagicNumber,0,argColor);
                if (Ticket >= 0)
                     OrderModify(Ticket,OrderOpenPrice(),argSL,argTP,0,CLR_NONE);
             }		  
                  
      return(0);
}

//+------------------------------------------------------------------+

//+-----------